﻿//
// renderPage.xaml.h
// renderPage 类的声明
//

#pragma once

#include "renderPage.g.h"
//
// renderPage.xaml.h
// Declaration of the renderPage class
//

#pragma once

#include "renderPage.g.h"
#include "Common\NavigationHelper.h"
#include "../../common_src/SDKDemoCommon.h"

#if !defined (_DEMOVIEW_) && !defined(_DEMOANNOT_)
using namespace SDKDemoCommon;
#endif
using namespace Windows::Storage::Pickers;

namespace demo_view
{

	/// <summary>
	/// A basic page that provides characteristics common to most applications.
	/// </summary>
	[Windows::Foundation::Metadata::WebHostHidden]
	public ref class renderPage sealed
	{
	public:
		renderPage();

		/// <summary>
		/// Gets the view model for this <see cref="Page"/>. 
		/// This can be changed to a strongly typed view model.
		/// </summary>
		property Windows::Foundation::Collections::IObservableMap<Platform::String^, Platform::Object^>^ DefaultViewModel
		{
			Windows::Foundation::Collections::IObservableMap<Platform::String^, Platform::Object^>^  get();
		}

		/// <summary>
		/// Gets the <see cref="NavigationHelper"/> associated with this <see cref="Page"/>.
		/// </summary>
		property Common::NavigationHelper^ NavigationHelper
		{
			Common::NavigationHelper^ get();
		}

		void ContinueFileOpenPicker(Windows::ApplicationModel::Activation::FileOpenPickerContinuationEventArgs^ args);

	protected:
		virtual void OnNavigatedTo(Windows::UI::Xaml::Navigation::NavigationEventArgs^ e) override;
		virtual void OnNavigatedFrom(Windows::UI::Xaml::Navigation::NavigationEventArgs^ e) override;

	private:
		void LoadState(Platform::Object^ sender, Common::LoadStateEventArgs^ e);
		void SaveState(Platform::Object^ sender, Common::SaveStateEventArgs^ e);
		void OpenPdfDocument(Windows::Storage::StorageFile^ file);
		void        PickPDFFile();

		bool		OpenDocumentSync(Windows::Storage::StorageFile^ pdfFile, int nFileSize, Platform::String^ password);
		FS_RESULT	LoadPage(int iPageIndex);
		void		GetPageInfo();
		void		CalcRenderSize();
		void		ShowPage();

		void		ReturnCommandInvokedHandler(Windows::UI::Popups::IUICommand^ command);

		static Windows::UI::Xaml::DependencyProperty^ _defaultViewModelProperty;
		static Windows::UI::Xaml::DependencyProperty^ _navigationHelperProperty;

		~renderPage();
		void		ReleaseResources();


		Windows::Storage::StorageFile^	m_pPDFFile;
		bool							m_bReleaseLibrary; // A flag used to indicate if SDK library has been initialized successfully and needs to be released.
		FSDK_Document^                  m_SDKDocument;
		FSCRT_DOCUMENT					m_PDFDoc; // SDK document handle of current loaded document.
		int                             m_iCurPageIndex; //Index of current loaded page.
		FSCRT_PAGE                      m_PDFPage; // SDK page handle of current loaded page.
		FS_FLOAT						m_fPageWidth; // Page width of current page.
		FS_FLOAT						m_fPageHeight; // Page Height of current page.
		
		//Used for rendering page.
		int								m_iStartX;
		int								m_iStartY;
		int								m_iRenderAreaSizeX;
		int								m_iRenderAreaSizeY;
		int                             m_iRotation;

		//Used for zooming.
		double							m_dbScaleDelta;
		double							m_dbScaleFator;
		double							m_dbCommonFitWidthScale;
		double							m_dbCommonFitHeightScale;
		double							m_dbRotateFitWidthScale;
		double							m_dbRotateFitHeightScale;
		bool							m_bFitWidth;
		bool							m_bFitHeight;

		//Event
		void		Click_BTN_NextPage(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void		Click_BTN_PrePage(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void		Click_BTN_RotateLeft(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void		Click_BTN_RotateRight(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void		Click_BTN_ZoomIn(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void		Click_BTN_ZoomOut(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void		Click_BTN_ActualSize(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void		Click_BTN_FitWidth(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
		void		Click_BTN_FitHeight(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);

	internal:
		static renderPage^ Current;
	};

}
